Confluence.QronCalcMacroTag = Confluence.QronCalcMacroTag || (function($) {

    function toColumnName(num) {
        for (var ret = '', a = 1, b = 26; (num -= a) >= 0; a = b, b *= 26) {
            ret = String.fromCharCode(parseInt((num % b) / a) + 65) + ret;
        }
        return ret;
    }

    function getBaseRow(table) {
        if (table.rows.length === 0) {
            return 0;
        }

        var lastCol = table.rows[0].cells.length - 1;
        for (var i = 0; i < table.rows.length; ++i) {
            // 最初にヘッダ以外(TD)が見つかったらその位置を返す
            if (table.rows[i].cells[lastCol].tagName !== 'TH') {
                return i;
            }
        }

        // ヘッダしかない場合
        return table.rows.length;
    }

    function getBaseCol(table) {
        if (table.rows.length === 0 || table.rows[0].cells.length === 0) {
            return 0;
        }

        var lastRow = table.rows.length - 1;
        for (var i = 0; i < table.rows[0].cells.length; ++i) {
            // 最初にヘッダ以外(TD)が見つかったらその位置を返す
            if (table.rows[lastRow].cells[i].tagName !== 'TH') {
                return i;
            }
        }

        return table.rows[lastRow].cell.length;
    }

    function show() {
        $('table').each(function(sheetIdx, table){

            // シートタグ
            $(table).prepend($('<caption class="qcm-tag qcm-sheet-tag">Sheet ' + (sheetIdx + 1) + '</caption>'));

            var baseRow = getBaseRow(table);
            var baseCol = getBaseCol(table);

            // 列にタグを埋め込む
            for (var col = baseCol; col < table.rows[0].cells.length; ++col) {
                var $cell = $(table.rows[0].cells[col]);
                $cell.prepend($('<span class="qcm-tag">' + toColumnName(col + (1 - baseCol)) + '</span>'));
            }

            // 行にタグを埋め込む
            for (var row = baseRow; row < table.rows.length; ++row) {
                var $cell = $(table.rows[row].cells[0]);
                $cell.prepend($('<span class="qcm-tag">' + (row + (1 - baseRow)) + '</span>'));
            }

        });
    }

    function hide() {
        $('.qcm-tag').remove();
    }

    return {
        show: show,
        hide: hide
    };
})(AJS.$);
